function [indP,indR,ISOamp,beat, signalfilt]=detectaP2(signal)

close all;
fm=300;pre=60; post=90;
% filtro paso bajo en 35 Hz
[b,a]=butter(5,35*2/fm,'low'); signal=filtfilt(b,a,signal);

% Deteccin de la onda R
[QRS,sign,en_thres] = qrs_detect2(signal',0.25,0.6,fm);
% intervalo de tiempo mnimo entre la onda P y la onda R
lapso=0.09*fm;
pw=[];
iso=[];
indR=[];
beat=[];

     ini=QRS(3)-pre;
     fin=QRS(3)+post;
     eval=signal(ini:fin);
% Buscar la onda P (valor mximo) en la ventana anterior al QRS, considerando el intervalo
% mnimo de tiempo      
     [maximo,indice]=max(eval(1:pre-lapso));
     isoelectric=prctile(eval(1:pre-lapso),25);
     pw=[pw;QRS(3)-(pre-indice)-1];
     iso=[iso;isoelectric];
     indR=[indR;QRS(3)];
     beat=[beat eval];

 
for i=4:length(QRS)-3
    ini=QRS(i)-pre;
    fin=QRS(i)+post;
    eval=signal(ini:fin);
    % slo incluirlo en el estudio del latido promedio si la ventana
    % [R_index-pre, R_index+post] est dentro de la ventana de anlisis
    beat=[beat eval];
    [maximo,indice]=max(eval(1:pre-lapso));
    isoelectric=prctile(eval(1:pre-lapso),25);
    pw=[pw;QRS(i)-(pre-indice)-1];
    iso=[iso;isoelectric];
    indR=[indR;QRS(i)];
end

pamp=signal(pw)'-iso;

pw_v=[];
indR_v=[];
iso_v=[];

for i=1:length(pamp)
    % Eliminando aquellas que se difiere demasiado al valor mediana 
    if pamp(i)>=0.3*median(pamp) 
       pw_v=[pw_v;pw(i)]; 
       indR_v=[indR_v; indR(i)];
       iso_v=[iso_v;iso(i)];
    end
end

% variables de salida
indP=pw_v;
ISOamp=iso_v;
indR=indR_v;
signalfilt=signal;

end