function [latidos,lim_vent, p] = enventana_QRS(ECG,pos,fs,v_ant_ms,v_pos_ms);
%latidos = enventanaQRS(ECG,v_ant,v_pos);
%
% Esta funcin enventana cada QRS del ECG y los organiza en una matriz. En
% el caso de que no haya suficiente seal para enventanar el primer y/o
% ltimo latido, los elimina. Si hay suficiente seal, los mantiene
% igualmente
%
% Entradas:
%   ECG [struct tipo ECG]: requiere ECG.senyal; ECG.fs; ECG.R
%
% Entradas opcionales
%   v_ant:  ventana anterior al R en ms
%   v_pos:  ventana posterior al R en ms
%
% Salida:
%   latidos [matriz]: QRS extrados, organizados en filas

p = 0;
ini = pos - round(v_ant_ms * fs / 1000);
fin = pos + round(v_pos_ms * fs / 1000);

if ini(1) < 0 & ini(2)>0
    %ECG.senyal = ECG.senyal(ini(2): length(ECG.senyal));
    pos = pos(2:length(pos));
    ini = pos - round(v_ant_ms * fs / 1000);
    fin = pos + round(v_pos_ms * fs / 1000);
    p = 1;
end
if fin(length(fin))>length(ECG) & fin(length(fin)-1)<length(ECG)
    %ECG.senyal = ECG.senyal(1: fin(length(fin)-1));
    pos = pos(1:length(pos) - 1);
    ini = pos - round(v_ant_ms * fs / 1000);
    fin = pos + round(v_pos_ms * fs / 1000);
    p = 2;
end
if fin(length(fin)-1)>length(ECG)
    pos = pos(1:length(pos) - 1);
    ini = pos - round(v_ant_ms * fs / 1000);
    fin = pos + round(v_pos_ms * fs / 1000);
    ECG = [ECG zeros(1,fin(length(fin))-length(ECG))];
    p = 3;
    
end
if ini(2)<0
    pos = pos(2:length(pos));
    ini = pos - round(v_ant_ms * fs / 1000);
    fin = pos + round(v_pos_ms * fs / 1000);
    ECG = [zeros(1,-ini(1)+1) ECG];
    ini(1) = 1;
    p = 4;
end
if ini(1)==0
    ini(1)=1;
    fin(1) = fin(1)+1;
end
lim_vent = [ini',fin'];
for i =1:length(lim_vent(:,1))
latidos(i,:) = ECG(lim_vent(i,1):lim_vent(i,2));
end


    


