function [latidos,lim_vent,Rn] = enventana_QRS(ECG,R,fs,v_ant_ms,v_pos_ms)
%latidos = enventanaQRS(ECG,v_ant,v_pos);
%
% Esta funcin enventana cada QRS del ECG y los organiza en una matriz. En
% el caso de que no haya suficiente seal para enventanar el primer y/o
% ltimo latido, los elimina. Si hay suficiente seal, los mantiene
% igualmente
%
% Entradas:
%   ECG [struct tipo ECG]: requiere ECG.senyal; ECG.fs; ECG.R
%
% Entradas opcionales
%   v_ant:  ventana anterior al R en ms
%   v_pos:  ventana posterior al R en ms
%
% Salida:
%   latidos [matriz]: QRS extrados, organizados en filas
ini = R - round(v_ant_ms * fs / 1000);
fin = R + round(v_pos_ms * fs / 1000);

pos_primer_ini=find(ini>0,1);
pos_ultimo_fin=max(find(fin<length(ECG)));

lim_vent = [ini(pos_primer_ini:pos_ultimo_fin)',fin(pos_primer_ini:pos_ultimo_fin)'];

for i =1:length(lim_vent(:,1))
latidos(i,:) = ECG(lim_vent(i,1):lim_vent(i,2));
end

Rn=R(pos_primer_ini:pos_ultimo_fin);
